                   
/*
 * File:        sidl_ucxx.hh
 * Copyright:   (c) 2001-2003 The Regents of the University of California
 * Release:     $Name: babel-release-0-9-6 $
 * Revision:    @(#) $Revision: 1.1 $
 * Date:        $Date: 2004/03/11 19:17:22 $
 * Description: Babel/C++ base classes 
 * AUTOMATICALLY GENERATED BY genSIDLcxx.py
 *
 */

#ifndef included_sidl_ucxx_hh
#define included_sidl_ucxx_hh

#ifndef __cplusplus
#error C++ headerfile: not meant for C compilers
#endif

#ifndef included_sidl_cxx_hh
#include "sidl_cxx.hh"
#endif

namespace sidl { 
  template<typename T> class pointer {
  public:
    typedef T element_type;

    explicit pointer(T* ptr=0)
      : ptr(ptr) {
      reference();
    }

    ~pointer() {
      dereference();
    }

    pointer(const pointer<T>& copy)
      : ptr(copy.ptr) {
      reference();
    }

    pointer<T>& operator=(const pointer<T>& copy) {
      copy.reference();
      dereference();
      ptr=copy.ptr;
      return *this;
    }

    pointer<T>& operator=(T* inptr) {
      if(inptr)
	inptr->_addReference();
      dereference();
      ptr=inptr;
      return *this;
    }

    // Allow casting from a derived class
    template<typename D> pointer(const pointer<D>& copy)
      : ptr(copy.getPointer()) {
      reference();
    }

    // Allow = from a derived class
    template<typename D>
    pointer<T>& operator=(const pointer<D>& inptr) {
      inptr.reference();
      dereference();
      ptr=inptr.getPointer();
      return *this;
    }

    inline T* operator->() const {
      //ASSERT(ptr != 0);
      return ptr;
    }
    inline T& operator*() const {
      //ASSERT(ptr != 0);
      return ptr;
    }
    inline T* getPointer() const {
	return ptr;
    }

    int useCount() const {
      return ptr?ptr->getReferenceCount():0;
    }
    bool isUnique() const {
      return ptr?ptr->getReferenceCount() == 1:false;
      // Returns false if ptr is null.  Should it be true, or should it throw?
    }
    bool isNull() const {
      return ptr == 0;
    }
    void reference() const {
      if(ptr)
	ptr->addRef();
    }
    void dereference() {
      if(ptr)
	ptr->deleteRef();
    }
  private:
    // mutable allows reference() to be used on a const pointer
    mutable T* ptr;
  };

  template<typename T>
  inline bool operator==(const pointer<T>& a, const pointer<T>& b)
  { return a.getPointer() == b.getPointer(); }

  template<typename T>
  inline bool operator!=(const pointer<T>& a, const pointer<T>& b)
    { return a.getPointer() != b.getPointer(); }
}

#endif // defined included_sidl_ucxx_hh
